package re.jimmitry.apps974.furious;
import re.jimmitry.apps974.furious.*;
import re.jimmitry.apps974.fursys.*;
import re.jimmitry.apps974.wsfurious.*;
import re.jimmitry.apps974.wsfurious.xsd.*;
import java.io.*;
import java.awt.*;
import java.util.Iterator;
import java.util.Set;
import java.math.BigInteger;
import java.text.SimpleDateFormat;
import org.apache.catalina.startup.*;
import org.apache.catalina.*;
import org.apache.catalina.core.*;
import javax.management.*;
public class FurPRGM_11 {
public static boolean AddClusteredSecInAllNode() {
  boolean b = true;
  try {
   VARIABLES[] vvv2 = new VARIABLES[1]; vvv2[0]=null;
   ACTIVITYO sqloB = FurPRGM_9.STARTACTIVITY("__CLUSTER" ,"ADDSECINALLNODESCLUSTER", vvv2); 
   if (sqloB.getNBERR()>0) {
   b=false;
        if (sqloB.getMsgs().getMsg()!=null) {
          for(int y=0;y<sqloB.getMsgs().getMsg().length;y++) {
		Fur_File.Trace2("ERROR: FurPRGM_11.AddClusteredSecInAllNode: "+sqloB.getMsgs().getMsg()[y].getTXT());
          }
        }
      }
  }
  catch (Exception e) { b=false;Fur_File.Trace2("ERROR: FurPRGM_11.AddClusteredSecInAllNode: "+e.getMessage());};
  return b;
};
public static boolean AddClusteredVirtualHost(String HostName, String Wid) {
  boolean b = true;
  try {
   VARIABLES vvv = new VARIABLES();
   VAR[] tabV = new VAR[2];
   VAR v = new VAR();v.setName("[HOSTNAME]");v.setValue(HostName);tabV[0]=v;
       v = new VAR();v.setName("[WID]");v.setValue(Wid);tabV[1]=v;
   vvv.setVar(tabV);
   VARIABLES[] vvv2 = new VARIABLES[1]; vvv2[0]=vvv;
   ACTIVITYO sqloB = FurPRGM_9.STARTACTIVITY("__CLUSTER" ,"ADDVIRTUALHOSTCLUSTER", vvv2); 
   if (sqloB.getNBERR()>0) {
   b=false;
        if (sqloB.getMsgs().getMsg()!=null) {
          for(int y=0;y<sqloB.getMsgs().getMsg().length;y++) {
		Fur_File.Trace2("ERROR: FurPRGM_11.AddClusteredVirtualHost: "+sqloB.getMsgs().getMsg()[y].getTXT());
          }
        }
      }
  }
  catch (Exception e) { b=false;Fur_File.Trace2("ERROR: FurPRGM_11.AddClusteredVirtualHost: "+e.getMessage());};
  return b;
};
public static boolean AddSecInAllNode() {
  boolean b = true;
  try {
    File z = new File("webapps/DBSConnector/SECURITY.zip");
    if (z.exists()) Fur_File.deleteFileFolder("webapps/DBSConnector/SECURITY.zip");
    String ZIP = FurPARAM.getZIPSECURITY().DATA;
    Fur_File.HEXWRITE(ZIP, "webapps/DBSConnector/SECURITY.zip");
    
    z = new File("webapps/DBSConnector/SECURITY");
    if (z.exists()) Fur_File.deleteFileFolder("webapps/DBSConnector/SECURITY");
    FurPRGM_9.unzipFolder("webapps/DBSConnector/SECURITY.zip", "webapps/DBSConnector/SECURITY");
  }
  catch (Exception e) { b=false;Fur_File.Trace("ERROR: FurPRGM_11.AddSecInAllNode: "+e.getMessage());};
  return b;
};
public static boolean AddVirtualHost(String HostName, String WebSite) {
  boolean b = true;
  try {
    File f = new File("webappsclients/"+WebSite);
    if (!f.exists()) f.mkdir();
    File f2 = new File("work/Catalina/"+HostName);
    if (f2.exists()) Fur_File.deleteFileFolder("work/Catalina/"+HostName);
    
    MBeanServer mBeanServer = MBeanServerFactory.findMBeanServer(null).get(0);
    ObjectName name = new ObjectName("Catalina", "type", "Server");
    Server server = (Server) mBeanServer.getAttribute(name, "managedResource");
    
    Service[] ss = server.findServices();
    Service kata = null;
    for(int oll=0;oll<ss.length;oll++) {
      if (ss[oll].getName().equals("Catalina")) kata = ss[oll];
    }
    
    Service serv = kata;
    org.apache.catalina.Container cont = serv.getContainer();
    StandardEngine engine = (StandardEngine) cont;
    
    
    StandardHost Sh = new StandardHost();
    Sh.setAppBase("webappsclients/"+WebSite);
    Sh.setName(HostName);
    if (HostName.indexOf("www.")!=-1) Sh.addAlias(HostName.replace("www.", ""));
    Sh.setAutoDeploy(true);
    Sh.setDeployOnStartup(true);
    Sh.setUnpackWARs(true);
    
    
    StandardContext ctx = new StandardContext();
    ctx.setPath("");
    ((Lifecycle) ctx).addLifecycleListener(new ContextConfig());
    ctx.setDocBase("../../webapps/"+WebSite);
    Sh.addChild(ctx);
    
    engine.addChild(Sh);

  }
  catch (Exception e) { b=false;Fur_File.Trace("ERROR: FurPRGM_11.AddVirtualHost: "+e.getMessage());};
  return b;
};
public static boolean ClearClusteredVirtualHost() {
  boolean b = true;
  try {
   VARIABLES[] vvv2 = new VARIABLES[1]; vvv2[0]=null;
   ACTIVITYO sqloB = FurPRGM_9.STARTACTIVITY("__CLUSTER" ,"CLEARVIRTUALHOSTCLUSTER", vvv2); 
   if (sqloB.getNBERR()>0) {
   b=false;
        if (sqloB.getMsgs().getMsg()!=null) {
          for(int y=0;y<sqloB.getMsgs().getMsg().length;y++) {
		Fur_File.Trace2("ERROR: FurPRGM_11.ClearClusteredVirtualHost: "+sqloB.getMsgs().getMsg()[y].getTXT());
          }
        }
      }
  }
  catch (Exception e) { b=false;Fur_File.Trace2("ERROR: FurPRGM_11.ClearClusteredVirtualHost: "+e.getMessage());};
  return b;
};
public static boolean ClearVirtualHost() {
  boolean b = true;int nb=0;
  try {

    MBeanServer mBeanServer = MBeanServerFactory.findMBeanServer(null).get(0);
    ObjectName name = new ObjectName("Catalina", "type", "Server");
    Server server = (Server) mBeanServer.getAttribute(name, "managedResource");
    
    Service[] ss = server.findServices();
    Service kata = null;
    for(int oll=0;oll<ss.length;oll++) {
      if (ss[oll].getName().equals("Catalina")) kata = ss[oll];
    }
    
    Service serv = kata;
    org.apache.catalina.Container cont = serv.getContainer();
    StandardEngine engine = (StandardEngine) cont;
    
    
    while (engine.findChildren().length>1) {
      for(int k1=0;k1<engine.findChildren().length;k1++) {
        //Fur_File.Trace(((StandardHost) engine.findChildren()[k1]).getAppBase());
        if (((StandardHost) engine.findChildren()[k1]).getAppBase().startsWith("webappsclients")) {engine.removeChild(((StandardHost) engine.findChildren()[k1]));nb++;}
      }
    }
    //Fur_File.Trace("CLEAR VIRTUALHOST: FurPRGM_11.ClearVirtualHost: "+nb);
  }
  catch (Exception e) { b=false;Fur_File.Trace("ERROR: FurPRGM_11.ClearVirtualHost: "+e.getMessage());};
  return b;
};
public static boolean CreerDBSCServer() {
  boolean b = true;
  File f = new File("webapps/DBSConnector/SECURITY/DBSCServer.sh");
  try {
    f.createNewFile();
    FileWriter fw = new FileWriter(f);
    fw.write("#!/bin/sh\n");
    fw.write("cd "+FurSYS_SchedulerPOOLSql.FIRSTUSERDIR+"/webapps/DBSConnector/SECURITY\n");
    fw.write("rm DBSCServer.csr\n");
    fw.write("rm DBSCServer.der\n");
    fw.write("rm DBSCServer.jks\n");
    fw.write("rm DBSCServer.pem\n");
    fw.write(Fur_System.getJavaHome()+"/../bin/keytool -genkey -alias DBSCServer -keyalg RSA -keystore DBSCServer.jks -storepass "+FurPARAM.getDBSConnectorParam("DBSCSERVER_STORE_PASS").DATA+" -keypass "+FurPARAM.getDBSConnectorParam("DBSCSERVER_KEY_PASS").DATA+" -dname \"CN="+FurPARAM.getDBSConnectorParam("DBSCSERVER_CN").DATA+",OU="+FurPARAM.getDBSConnectorParam("DBSCSERVER_OU").DATA+",O="+FurPARAM.getDBSConnectorParam("DBSCSERVER_O").DATA+",L="+FurPARAM.getDBSConnectorParam("DBSCSERVER_L").DATA+",S="+FurPARAM.getDBSConnectorParam("DBSCSERVER_S").DATA+",C="+FurPARAM.getDBSConnectorParam("DBSCSERVER_C").DATA+"\"\n");
    fw.write(Fur_System.getJavaHome()+"/../bin/keytool -certreq -keyalg RSA -alias DBSCServer -file DBSCServer.csr -keystore DBSCServer.jks -storepass "+FurPARAM.getDBSConnectorParam("DBSCSERVER_STORE_PASS").DATA+"\n");
    fw.write("openssl x509 -req -in DBSCServer.csr -out DBSCServer.pem -CA "+FurSYS_SchedulerPOOLSql.FIRSTUSERDIR+"/webapps/DBSConnector/SECURITY/DBSConnector/cacert.pem -CAkey "+FurSYS_SchedulerPOOLSql.FIRSTUSERDIR+"/webapps/DBSConnector/SECURITY/DBSConnector/private/cakey.pem -days "+FurPARAM.getDBSConnectorParam("DBSCSERVER_DAY_LIMIT").DATA+" -CAcreateserial -sha1 -trustout -passin pass:"+FurPARAM.getDBSConnectorParam("CA_PASSWORD").DATA+"\n");
    fw.write("openssl x509 -req -in DBSCServer.csr -out DBSCServer.pem -CA "+FurSYS_SchedulerPOOLSql.FIRSTUSERDIR+"/webapps/DBSConnector/SECURITY/DBSConnector/cacert.pem -CAkey "+FurSYS_SchedulerPOOLSql.FIRSTUSERDIR+"/webapps/DBSConnector/SECURITY/DBSConnector/private/cakey.pem -days "+FurPARAM.getDBSConnectorParam("DBSCSERVER_DAY_LIMIT").DATA+" -CAserial "+FurSYS_SchedulerPOOLSql.FIRSTUSERDIR+"/webapps/DBSConnector/SECURITY/DBSConnector/serial -sha1 -trustout -passin pass:"+FurPARAM.getDBSConnectorParam("CA_PASSWORD").DATA+"\n");
    fw.write("openssl verify -CAfile "+FurSYS_SchedulerPOOLSql.FIRSTUSERDIR+"/webapps/DBSConnector/SECURITY/DBSConnector/cacert.pem -purpose sslserver DBSCServer.pem\n");
    fw.write("openssl x509 -in DBSCServer.pem -inform PEM -out DBSCServer.der -outform DER\n");
    fw.write(Fur_System.getJavaHome()+"/../bin/keytool -import -alias langhua-root -file "+FurSYS_SchedulerPOOLSql.FIRSTUSERDIR+"/webapps/DBSConnector/SECURITY/DBSConnector/cacert.der -keystore DBSCServer.jks -storepass "+FurPARAM.getDBSConnectorParam("DBSCSERVER_STORE_PASS").DATA+" -noprompt\n");
    fw.write(Fur_System.getJavaHome()+"/../bin/keytool -printcert -file DBSCServer.der\n");
    fw.write(Fur_System.getJavaHome()+"/../bin/keytool -import -trustcacerts -alias DBSCServer -file DBSCServer.der -keystore DBSCServer.jks -storepass "+FurPARAM.getDBSConnectorParam("DBSCSERVER_STORE_PASS").DATA+" -noprompt\n");
    fw.write(Fur_System.getJavaHome()+"/../bin/keytool -list -v -keystore DBSCServer.jks -storepass "+FurPARAM.getDBSConnectorParam("DBSCSERVER_STORE_PASS").DATA+"\n");
    fw.write(Fur_System.getJavaHome()+"/../bin/keytool -delete -alias CADBSCReunion -keystore "+FurPARAM.getDBSConnectorParam("CERT_JRE_KEYSTORE_FILE").DATA+" -storepass "+FurPARAM.getDBSConnectorParam("CERT_JRE_KEYSTORE_PASSWORD").DATA+"\n");
    fw.write(Fur_System.getJavaHome()+"/../bin/keytool -import -alias CADBSCReunion -file "+FurSYS_SchedulerPOOLSql.FIRSTUSERDIR+"/webapps/DBSConnector/SECURITY/cacert.der -keystore "+FurPARAM.getDBSConnectorParam("CERT_JRE_KEYSTORE_FILE").DATA+" -storepass "+FurPARAM.getDBSConnectorParam("CERT_JRE_KEYSTORE_PASSWORD").DATA+" -noprompt\n");
    fw.flush();
    fw.close();
  }
  catch (Exception e) { b=false;Fur_File.Trace("ERROR: FurPRGM_11.CreerDBSCServer: "+e.getMessage());};
  return b;
};
public static boolean CreerPKCS12(String name) {
  boolean b = true;
  File f = new File("webapps/DBSConnector/SECURITY/PKCS12/"+name);
  try {
    f.mkdir();
    File g = new File("webapps/DBSConnector/SECURITY/PKCS12/"+name+"/info");
    File h = new File("webapps/DBSConnector/SECURITY/PKCS12/"+name+"/USERS");
    g.createNewFile();
    h.mkdir();
    FileWriter fw = new FileWriter(g);
    fw.write("[PKINFOS]\n");
    fw.write("Name="+name+"\n");
    fw.write("countryName="+FurPARAM.getDBSConnectorParam("CA_C").DATA+"\n");
    fw.write("stateOrProvinceName="+FurPARAM.getDBSConnectorParam("CA_ST").DATA+"\n");
    fw.write("localityName="+FurPARAM.getDBSConnectorParam("CA_L").DATA+"\n");
    fw.write("organizationalUnitName="+FurPARAM.getDBSConnectorParam("CA_OU").DATA+"\n");
    fw.write("organizational="+FurPARAM.getDBSConnectorParam("CA_O").DATA+"\n");
    fw.write("commonName="+FurPARAM.getDBSConnectorParam("CA_CN").DATA+"\n");
    fw.write("emailAddress="+FurPARAM.getDBSConnectorParam("CA_EMAIL_ADRESS").DATA+"\n");
    fw.write("passin="+FurPARAM.getDBSConnectorParam("CA_PASSWORD").DATA+"\n");
    fw.write("daylimit="+FurPARAM.getDBSConnectorParam("CA_DAY_LIMIT").DATA+"\n");
    fw.flush();
    fw.close();
  }
  catch (Exception e) { b=false;Fur_File.Trace("ERROR: FurPRGM_11.CreerPKCS12: "+e.getMessage());};
  return b;
};
public static boolean CreerUser(String name, String user) {
  boolean b = true;
  File f = new File("webapps/DBSConnector/SECURITY/PKCS12/"+name+"/USERS/"+user);
  try {
    f.mkdir();
    File g = new File("webapps/DBSConnector/SECURITY/PKCS12/"+name+"/USERS/"+user+"/info");
    File h = new File("webapps/DBSConnector/SECURITY/PKCS12/"+name+"/USERS/"+user+"/PKS");
    g.createNewFile();
    h.mkdir();
    FileWriter fw = new FileWriter(g);
    fw.write("[PKINFOS]\n");
    fw.write("Name="+user+"\n");
    fw.write("countryName="+FurPARAM.getDBSConnectorParam("CU_C").DATA+"\n");
    fw.write("stateOrProvinceName="+FurPARAM.getDBSConnectorParam("CU_ST").DATA+"\n");
    fw.write("localityName="+FurPARAM.getDBSConnectorParam("CU_L").DATA+"\n");
    fw.write("organizationalUnitName="+FurPARAM.getDBSConnectorParam("CU_OU").DATA+"\n");
    fw.write("organizational="+user+FurPARAM.getDBSConnectorParam("CU_O").DATA+"\n");
    if (user.equals("dbsconnector")) fw.write("commonName="+FurPARAM.getDBSConnectorParam("LOCALIP").DATA+"\n");
    else fw.write("commonName="+FurPARAM.getDBSConnectorParam("CU_CN").DATA+" ("+user+")"+"\n");
    fw.write("emailAddress="+user+FurPARAM.getDBSConnectorParam("CU_EMAIL_ADRESS").DATA+"\n");
    fw.write("passin="+FurPARAM.getDBSConnectorParam("CU_PASSWORD").DATA+"\n");
    fw.write("daylimit="+FurPARAM.getDBSConnectorParam("CU_DAY_LIMIT").DATA+"\n");
    fw.flush();
    fw.close();
  }
  catch (Exception e) { b=false;Fur_File.Trace("ERROR: FurPRGM_11.CreerUser: "+e.getMessage());};
  return b;
};
public static boolean DelPKCS12(String Name) {
  return Fur_File.deleteFileFolder("webapps/DBSConnector/SECURITY/PKCS12/"+Name);
};
public static boolean ExistCA(String PaCA)
{
  if (!PaCA.equals("")) {
    File f = new File("webapps/DBSConnector/SECURITY/PKCS12/"+PaCA);
    return f.exists();
  } else return false;
}
public static boolean GenerateCA(String name) {
  boolean b = true;
  try {
    String DN="";
  if (!FurPARAM.getDBSConnectorParam("CA_EMAIL_ADRESS").DATA.equals("")) DN+="EmailAddress="+
    FurPARAM.getDBSConnectorParam("CA_EMAIL_ADRESS").DATA.replace(",", "")+",";
  if (!FurPARAM.getDBSConnectorParam("CA_CN").DATA.equals("")) DN+="CN="+
    FurPARAM.getDBSConnectorParam("CA_CN").DATA.replace(",", "")+",";
  if (!FurPARAM.getDBSConnectorParam("CA_OU").DATA.equals("")) DN+="OU="+
    FurPARAM.getDBSConnectorParam("CA_OU").DATA.replace(",", "")+",";
  if (!FurPARAM.getDBSConnectorParam("CA_O").DATA.equals("")) DN+="O="+
    FurPARAM.getDBSConnectorParam("CA_O").DATA.replace(",", "")+",";
  if (!FurPARAM.getDBSConnectorParam("CA_L").DATA.equals("")) DN+="L="+
    FurPARAM.getDBSConnectorParam("CA_L").DATA.replace(",", "")+",";
  if (!FurPARAM.getDBSConnectorParam("CA_ST").DATA.equals("")) DN+="ST="+
    FurPARAM.getDBSConnectorParam("CA_ST").DATA.replace(",", "")+",";
  if (!FurPARAM.getDBSConnectorParam("CA_C").DATA.equals("")) DN+="C="+
    FurPARAM.getDBSConnectorParam("CA_C").DATA.replace(",", "")+",";
  DN=DN.substring(0, DN.length()-1);
X509CertificateGenerator.createNewCa(DN, Integer.parseInt(FurPARAM.getDBSConnectorParam("CA_DAY_LIMIT").DATA), "webapps/DBSConnector/SECURITY/PKCS12/"+name+"/ca.p12", FurPARAM.getDBSConnectorParam("CA_PASSWORD").DATA, "dbsconnector_ca");
b=X509CertificateGenerator.writeCERFile(new FileInputStream(new File("webapps/DBSConnector/SECURITY/PKCS12/"+name+"/ca.p12")), FurPARAM.getDBSConnectorParam("CA_PASSWORD").DATA, "dbsconnector_ca", "webapps/DBSConnector/SECURITY/PKCS12/"+name+"/ca.cer");
  }
  catch (Exception e) { b=false;Fur_File.Trace2("ERROR: FurPRGM_11.GenerateCA: "+e.getMessage());};
  return b;
};
public static boolean GenerateCACluster() {
  boolean b = true;
  try {
    
    b=GenerateCA("DBSCONNECTOR") && b;
    b=GenerateCU("DBSCONNECTOR", "dbsconnector") && b;
    b=GenerateCUROOT("DBSCONNECTOR", "root") && b;
    File z = new File("webapps/DBSConnector/SECURITY.zip");
    if (z.exists()) Fur_File.deleteFileFolder("webapps/DBSConnector/SECURITY.zip");
    FurPRGM_9.zipFolder2("webapps/DBSConnector/SECURITY", "webapps/DBSConnector/SECURITY.zip");
    
    FurPRGM_6.EXE("update SYSTEM_PARAMS set VALUE='"+Fur_File.HEXREAD("webapps/DBSConnector/SECURITY.zip")+"' where PARAM='CLUSTER_SECURITY_ZIP';");
    
  }
  catch (Exception e) { b=false;Fur_File.Trace2("ERROR: FurPRGM_11.GenerateCACluster: "+e.getMessage());};
  return b;
};
public static boolean GenerateCU(String name, String user) {
  boolean b = true;
  try {
        
  String DN="";
  if (!FurPARAM.getDBSConnectorParam("CU_EMAIL_ADRESS").DATA.equals("")) DN+="EmailAddress="+
    FurPARAM.getDBSConnectorParam("CU_EMAIL_ADRESS").DATA.replace(",", "")+",";
  if (!FurPARAM.getDBSConnectorParam("CU_CN").DATA.equals("")) DN+="CN="+
    FurPARAM.getDBSConnectorParam("CU_CN").DATA.replace(",", "")+",";
  if (!FurPARAM.getDBSConnectorParam("CU_OU").DATA.equals("")) DN+="OU="+
    FurPARAM.getDBSConnectorParam("CU_OU").DATA.replace(",", "")+",";
  if (!FurPARAM.getDBSConnectorParam("CU_O").DATA.equals("")) DN+="O="+
    FurPARAM.getDBSConnectorParam("CU_O").DATA.replace(",", "")+",";
  if (!FurPARAM.getDBSConnectorParam("CU_L").DATA.equals("")) DN+="L="+
    FurPARAM.getDBSConnectorParam("CU_L").DATA.replace(",", "")+",";
  if (!FurPARAM.getDBSConnectorParam("CU_ST").DATA.equals("")) DN+="ST="+
    FurPARAM.getDBSConnectorParam("CU_ST").DATA.replace(",", "")+",";
  if (!FurPARAM.getDBSConnectorParam("CU_C").DATA.equals("")) DN+="C="+
    FurPARAM.getDBSConnectorParam("CU_C").DATA.replace(",", "")+",";
  DN=DN.substring(0, DN.length()-1);
    b=new X509CertificateGenerator("webapps/DBSConnector/SECURITY/PKCS12/"+name+"/ca.p12", FurPARAM.getDBSConnectorParam("CA_PASSWORD").DATA, "dbsconnector_ca").createCertificate(DN, Integer.parseInt(FurPARAM.getDBSConnectorParam("CU_DAY_LIMIT").DATA), "webapps/DBSConnector/SECURITY/PKCS12/"+name+"/USERS/"+user+"/PKS/dbsconnector.p12", FurPARAM.getDBSConnectorParam("CU_PASSWORD").DATA, "dbsconnector_cu");


  }
  catch (Exception e) { b=false;Fur_File.Trace2("ERROR: FurPRGM_11.GenerateCU: "+e.getMessage());};
  return b;
};
public static boolean GenerateCUCluster() {
  boolean b = true;
  try {
    
    b=GenerateCU("DBSCONNECTOR", "dbsconnector") && b;
    
    File z = new File("webapps/DBSConnector/SECURITY.zip");
    if (z.exists()) Fur_File.deleteFileFolder("webapps/DBSConnector/SECURITY.zip");
    FurPRGM_9.zipFolder2("webapps/DBSConnector/SECURITY", "webapps/DBSConnector/SECURITY.zip");
    
    FurPRGM_6.EXE("update SYSTEM_PARAMS set VALUE='"+Fur_File.HEXREAD("webapps/DBSConnector/SECURITY.zip")+"' where PARAM='CLUSTER_SECURITY_ZIP';");
    
  }
  catch (Exception e) { b=false;Fur_File.Trace2("ERROR: FurPRGM_11.GenerateCUCluster: "+e.getMessage());};
  return b;
};
public static boolean GenerateCUROOT(String name, String user) {
  boolean b = true;
  try {
  String DN="";
  if (!FurPARAM.getDBSConnectorParam("CUROOT_EMAIL_ADRESS").DATA.equals("")) DN+="EmailAddress="+
    FurPARAM.getDBSConnectorParam("CUROOT_EMAIL_ADRESS").DATA.replace(",", "")+",";
  if (!FurPARAM.getDBSConnectorParam("CUROOT_CN").DATA.equals("")) DN+="CN="+
    FurPARAM.getDBSConnectorParam("CUROOT_CN").DATA.replace(",", "")+",";
  if (!FurPARAM.getDBSConnectorParam("CUROOT_OU").DATA.equals("")) DN+="OU="+
    FurPARAM.getDBSConnectorParam("CUROOT_OU").DATA.replace(",", "")+",";
  if (!FurPARAM.getDBSConnectorParam("CUROOT_O").DATA.equals("")) DN+="O="+
    FurPARAM.getDBSConnectorParam("CUROOT_O").DATA.replace(",", "")+",";
  if (!FurPARAM.getDBSConnectorParam("CUROOT_L").DATA.equals("")) DN+="L="+
    FurPARAM.getDBSConnectorParam("CUROOT_L").DATA.replace(",", "")+",";
  if (!FurPARAM.getDBSConnectorParam("CUROOT_ST").DATA.equals("")) DN+="ST="+
    FurPARAM.getDBSConnectorParam("CUROOT_ST").DATA.replace(",", "")+",";
  if (!FurPARAM.getDBSConnectorParam("CUROOT_C").DATA.equals("")) DN+="C="+
    FurPARAM.getDBSConnectorParam("CUROOT_C").DATA.replace(",", "")+",";
  DN=DN.substring(0, DN.length()-1);

b=new X509CertificateGenerator("webapps/DBSConnector/SECURITY/PKCS12/"+name+"/ca.p12", FurPARAM.getDBSConnectorParam("CA_PASSWORD").DATA, "dbsconnector_ca").createCertificate(DN, Integer.parseInt(FurPARAM.getDBSConnectorParam("CUROOT_DAY_LIMIT").DATA), "webapps/DBSConnector/SECURITY/PKCS12/"+name+"/USERS/"+user+"/PKS/dbsconnector_"+FurPARAM.getDBSConnectorParam("CUROOT_O").DATA.replace("/", "_").replace(";", "_").replace("*", ".")+"_"+Fur_Date.getSysDateMinAff()+".p12", FurPARAM.getDBSConnectorParam("CUROOT_PASSWORD").DATA, user+"_cu");



  }
  catch (Exception e) { b=false;Fur_File.Trace2("ERROR: FurPRGM_11.GenerateCUROOT: "+e.getMessage());};
  return b;
};
public static boolean GenerateCUROOTCluster() {
  boolean b = true;
  try {
    
    b=GenerateCUROOT("DBSCONNECTOR", "root") && b;
    
    File z = new File("webapps/DBSConnector/SECURITY.zip");
    if (z.exists()) Fur_File.deleteFileFolder("webapps/DBSConnector/SECURITY.zip");
    FurPRGM_9.zipFolder2("webapps/DBSConnector/SECURITY", "webapps/DBSConnector/SECURITY.zip");
    
    FurPRGM_6.EXE("update SYSTEM_PARAMS set VALUE='"+Fur_File.HEXREAD("webapps/DBSConnector/SECURITY.zip")+"' where PARAM='CLUSTER_SECURITY_ZIP';");
    
  }
  catch (Exception e) { b=false;Fur_File.Trace2("ERROR: FurPRGM_11.GenerateCUROOTCluster: "+e.getMessage());};
  return b;
};
public static FurSYS_DATA GenerateUSERCU(String user, String EmailAddress, String CN, String OU, String O, String L
, String ST, String C, String daylimit, String passin) {
  boolean b = true;
	String DN="", strDateTMP=Fur_Date.getSysDateMinAff();
  try {
  
  DN+="EmailAddress="+
    EmailAddress.replace(",", "")+",";
  DN+="CN="+
    CN.replace(",", "")+",";
  DN+="OU="+
    OU.replace(",", "")+",";
  DN+="O="+
    O.replace(",", "")+",";
  DN+="L="+
    L.replace(",", "")+",";
  DN+="ST="+
    ST.replace(",", "")+",";
  DN+="C="+
    C.replace(",", "")+",";
  DN=DN.substring(0, DN.length()-1);
  b=new X509CertificateGenerator("webapps/DBSConnector/SECURITY/PKCS12/DBSCONNECTOR/ca.p12", 
	FurPARAM.getDBSConnectorParam("CA_PASSWORD").DATA, "dbsconnector_ca").createCertificate(
	DN, Integer.parseInt(daylimit)
	, "temp/"+user+"_"+strDateTMP+".p12", passin
	, user+"_cu");
  }
  catch (Exception e) { b=false;Fur_File.Trace2("ERROR: FurPRGM_11.GenerateUSERCU: "+e.getMessage());};
	if (b) return new FurSYS_DATA(false, "temp/"+user+"_"+strDateTMP+".p12");
  else return new FurSYS_DATA(true, "(null)");
};
public static boolean InitClusteredFileNode() {
  boolean b = true;
  try {
   VARIABLES[] vvv2 = new VARIABLES[1]; vvv2[0]=null;
   ACTIVITYO sqloB = FurPRGM_9.STARTACTIVITY("__CLUSTER" ,"INITFILENODECLUSTER", vvv2); 
   if (sqloB.getNBERR()>0) {
   b=false;
        if (sqloB.getMsgs().getMsg()!=null) {
          for(int y=0;y<sqloB.getMsgs().getMsg().length;y++) {
		Fur_File.Trace2("ERROR: FurPRGM_11.InitClusteredFileNode: "+sqloB.getMsgs().getMsg()[y].getTXT());
          }
        }
      }
  }
  catch (Exception e) { b=false;Fur_File.Trace2("ERROR: FurPRGM_11.InitClusteredFileNode: "+e.getMessage());};
  return b;
};
public static boolean InitFileNode() {
  boolean b = true;
  try {
    //Ecrit dans les fichies de config ...
    String NODEID=Fur_File.getINIinfos("PARAM.INI", "CLUSTER_APP", "NODE_ID");
    
    if (!FurPARAM.getIfInitClusterNewID(NODEID).DATA.equals("0")) {
      NODEID=FurPARAM.getInitClusterParamOLDID(NODEID, "ID").DATA;
    }
    
    
    File f3 = new File("PARAM.INI");
    f3.createNewFile();
    FileWriter fw3 = new FileWriter(f3);
    
    fw3.write("[DATABASE]\n");
    fw3.write("TIMEOUT_FOR_VALID_CONNECTION="+FurPARAM.getInitClusterParam(NODEID, "CNXTIMEOUT").DATA+"\n\n");
    
    fw3.write("[WARNING_RESERVED_PORT_8001_TO_8009]\n");
    fw3.write("#RESERVED_PORT=You can t change it ! All port used by Application Manager kernel.\n");
    fw3.write("#HTTP_PORT=8001 Used for http socket by Application Manager kernel.\n");
    fw3.write("#HTTPS_PORT=8002 Used for https socket by Application Manager kernel.\n");
    fw3.write("#HTTPS_PRIV_PORT=8007 Used for https_priv socket by Application Manager kernel.\n");
    fw3.write("#HTTPS_AUTH_PORT=8003 Used for https_auth socket by Application Manager kernel.\n");
    fw3.write("#AJP=8004(https), 8006(https_auth), 8008(https_priv) Used by Tomcat kernel.\n");
    fw3.write("#SERVER=8005(shutdown) Used by Tomcat kernel.\n");
    fw3.write("#H2_INI_CLUSTER_PORT=8009 Used for initilize cluster H2.\n\n");

    fw3.write("[LOAD_BALANCER]\n");
    fw3.write("LISTEN_PORT_HTTP="+FurPARAM.getInitClusterParam(NODEID, "LBHTTPPORT").DATA+"\n");
    fw3.write("LISTEN_PORT_HTTPS="+FurPARAM.getInitClusterParam(NODEID, "LBHTTPSPORT").DATA+"\n");    
    fw3.write("LISTEN_PORT_HTTPS_AUTH="+FurPARAM.getInitClusterParam(NODEID, "LBHTTPSAUTHPORT").DATA+"\n");
    fw3.write("LISTEN_PORT_HTTPS_PRIV="+FurPARAM.getInitClusterParam(NODEID, "LBHTTPSPRIVPORT").DATA+"\n\n");

    fw3.write("[CLUSTER_APP]\n");
    fw3.write("NODE_ID="+NODEID+"\n");
    fw3.write("NODE_ID_HOST="+FurPARAM.getInitClusterParam(NODEID, "HOST").DATA+"\n");
    fw3.write("NODE_LOG="+FurPARAM.getInitClusterParam(NODEID, "LOGSIZE").DATA+"\n");
    fw3.write("LOAD_ALL_CRON_ACTIVITY="+FurPARAM.getInitClusterParam(NODEID, "LOADCRONTAB").DATA+"\n\n");
              
    fw3.write("[MYSQL_CONFIG]\n");
    fw3.write("NBNODE="+FurPARAM.getInitClusterParam(NODEID, "MYSQLCONFIG").DATA+"\n");
    fw3.write("N1HOST="+FurPARAM.getInitClusterParam(NODEID, "N1HOST").DATA+"\n");
    fw3.write("N1PORT="+FurPARAM.getInitClusterParam(NODEID, "N1PORT").DATA+"\n");
    fw3.write("N2HOST="+FurPARAM.getInitClusterParam(NODEID, "N2HOST").DATA+"\n");
    fw3.write("N2PORT="+FurPARAM.getInitClusterParam(NODEID, "N2PORT").DATA+"\n");
    
    fw3.write("USER="+FurPARAM.getInitClusterParam(NODEID, "MYSQLUSER").DATA+"\n");
    fw3.write("PASSWORD="+FurPARAM.getInitClusterParam(NODEID, "MYSQLPASSWORD").DATA+"\n\n");

    fw3.write("[CERTIFICATION]\n");
    fw3.write("MULTI_HOST="+FurPARAM.getDBSConnectorParam("CLUSTER_CERT_MULTI_HOST").DATA+"\n\n");

    fw3.flush();
    fw3.close();
    
    FurPRGM_6.EXE("update SYSTEM_CLUSTER set INITFILE=CURRENT_TIMESTAMP where ID="+NODEID+";");
  }
  catch (Exception e) { b=false;Fur_File.Trace("ERROR: FurPRGM_11.InitFileNode: "+e.getMessage());};
  return b;
};
public static boolean InitVirtualHost() {
  boolean b = true;
  try {
   VARIABLES[] vvv2 = new VARIABLES[1]; vvv2[0]=null;
   ACTIVITYO sqloB = FurPRGM_9.STARTACTIVITY("__REDIRECT" ,"NBEXELOCAL", vvv2); 
   if (sqloB.getNBERR()>0) {
   b=false;
        if (sqloB.getMsgs().getMsg()!=null) {
          for(int y=0;y<sqloB.getMsgs().getMsg().length;y++) {
		Fur_File.Trace2("ERROR: FurPRGM_11.InitVirtualHost: "+sqloB.getMsgs().getMsg()[y].getTXT());
          }
        }
      }
  }
  catch (Exception e) { b=false;Fur_File.Trace2("ERROR: FurPRGM_11.InitVirtualHost: "+e.getMessage());};
  return b;
};
public static boolean LBIntegrateClusteredPile() {
  boolean b = true;
  try {
   VARIABLES[] vvv2 = new VARIABLES[1]; vvv2[0]=null;
   ACTIVITYO sqloB = FurPRGM_9.STARTACTIVITY("__CLUSTER" ,"LBINTEGRATECLUSTEREDPILE", vvv2); 
   if (sqloB.getNBERR()>0) {
   b=false;
        if (sqloB.getMsgs().getMsg()!=null) {
          for(int y=0;y<sqloB.getMsgs().getMsg().length;y++) {
		Fur_File.Trace2("ERROR: FurPRGM_11.LBIntegrateClusteredPile: "+sqloB.getMsgs().getMsg()[y].getTXT());
          }
        }
      }
  }
  catch (Exception e) { b=false;Fur_File.Trace2("ERROR: FurPRGM_11.LBIntegrateClusteredPile: "+e.getMessage());};
  return b;
};
public static boolean LBIntegratePile() {
  boolean b = true;
  try {
    LoadBalancerA.indexPILE=Integer.parseInt(FurPARAM.getDBSConnectorParam("TRACKING_PILEMAX_HTTP").DATA);
    LoadBalancerS.indexPILE=Integer.parseInt(FurPARAM.getDBSConnectorParam("TRACKING_PILEMAX_HTTPS").DATA);
    LoadBalancerSAuth.indexPILE=Integer.parseInt(FurPARAM.getDBSConnectorParam("TRACKING_PILEMAX_HTTPS_AUTH").DATA);
    LoadBalancerSPriv.indexPILE=Integer.parseInt(FurPARAM.getDBSConnectorParam("TRACKING_PILEMAX_HTTPS_PRIV").DATA);
  }
  catch (Exception e) { b=false;Fur_File.Trace("ERROR: FurPRGM_11.LBIntegratePile: "+e.getMessage());};
  return b;
};
public static boolean MKPKCS12(String name, String countryName, String stateOrProvinceName, String localityName, String organizationalUnitName, String commonName, String emailAddress, String passin) {
  boolean b = false;
  try {
    b=new X509CertificateGenerator("webapps/DBSConnector/SECURITY/PKCS12/"+name+"/ca.p12", Fur_File.getINIinfos("webapps/DBSConnector/SECURITY/PKCS12/"+name+"/info", "PKINFOS", "passin"), "ca").createCertificate("test cn2", 180, "webapps/DBSConnector/SECURITY/PKCS12/"+name+"/PKS/dbsconnector.p12", "test");

  }
  catch (Exception e) { Fur_File.Trace("ERROR: FurPRGM_11.MKPKCS12: "+e.getMessage());};
  return b;
};
public static boolean ModifPKCS12(String name, String paramName, String countryName, String stateOrProvinceName, String localityName, String organizationalUnitName, String commonName, String emailAddress, String passin, String daylimit, String organizational) {
  boolean b = true;
  try {
    File g = new File("webapps/DBSConnector/SECURITY/PKCS12/"+name+"/info");
    g.createNewFile();
    FileWriter fw = new FileWriter(g);
    fw.write("[PKINFOS]\n");
    fw.write("Name="+paramName+"\n");
    fw.write("countryName="+countryName+"\n");
    fw.write("stateOrProvinceName="+stateOrProvinceName+"\n");
    fw.write("localityName="+localityName+"\n");
    fw.write("organizationalUnitName="+organizationalUnitName+"\n");
    fw.write("organizational="+organizational+"\n");
    fw.write("commonName="+commonName+"\n");
    fw.write("emailAddress="+emailAddress+"\n");
    fw.write("passin="+passin+"\n");
    fw.write("daylimit="+daylimit+"\n");
    fw.flush();
    fw.close();
  }
  catch (Exception e) { b=false;Fur_File.Trace("ERROR: FurPRGM_11.ModifPKCS12: "+e.getMessage());};
  return b;
};
public static boolean ModifUser(String name, String user, String paramName, String countryName, String stateOrProvinceName, String localityName, String organizationalUnitName, String commonName, String emailAddress, String passin, String daylimit, String organizational) {
  boolean b = true;
  try {
    File g = new File("webapps/DBSConnector/SECURITY/PKCS12/"+name+"/USERS/"+user+"/info");
    g.createNewFile();
    FileWriter fw = new FileWriter(g);
    fw.write("[PKINFOS]\n");
    fw.write("Name="+paramName+"\n");
    fw.write("countryName="+countryName+"\n");
    fw.write("stateOrProvinceName="+stateOrProvinceName+"\n");
    fw.write("localityName="+localityName+"\n");
    fw.write("organizationalUnitName="+organizationalUnitName+"\n");
    fw.write("organizational="+organizational+"\n");
    fw.write("commonName="+commonName+"\n");
    fw.write("emailAddress="+emailAddress+"\n");
    fw.write("passin="+passin+"\n");
    fw.write("daylimit="+daylimit+"\n");
    fw.flush();
    fw.close();
  }
  catch (Exception e) { b=false;Fur_File.Trace("ERROR: FurPRGM_11.ModifUser: "+e.getMessage());};
  return b;
};
public static boolean ModifUser2(String name, String user, String paramName, String countryName, String stateOrProvinceName, String localityName, String organizationalUnitName, String commonName, String emailAddress, String passin, String daylimit, String organizational) {
  boolean b = true;
  try {
    File g = new File("../webapps/DBSConnector/SECURITY/PKCS12/"+name+"/USERS/"+user+"/info");
    g.createNewFile();
    FileWriter fw = new FileWriter(g);
    fw.write("[PKINFOS]\n");
    fw.write("Name="+paramName+"\n");
    fw.write("countryName="+countryName+"\n");
    fw.write("stateOrProvinceName="+stateOrProvinceName+"\n");
    fw.write("localityName="+localityName+"\n");
    fw.write("organizationalUnitName="+organizationalUnitName+"\n");
    fw.write("organizational="+organizational+"\n");
    fw.write("commonName="+commonName+"\n");
    fw.write("emailAddress="+emailAddress+"\n");
    fw.write("passin="+passin+"\n");
    fw.write("daylimit="+daylimit+"\n");
    fw.flush();
    fw.close();
  }
  catch (Exception e) { b=false;Fur_File.Trace("ERROR: FurPRGM_11.ModifUser2: "+e.getMessage());};
  return b;
};
public static boolean Revoke(String CA, String User, String CU) {
  boolean b = true;
  try {
    BigInteger bb = X509CertificateGenerator.getSerialNumber("webapps/DBSConnector/SECURITY/PKCS12/"+CA+"/ca.p12", FurPARAM.getDBSConnectorParam("CA_PASSWORD").DATA, "dbsconnector_ca");
    BigInteger bb2 = X509CertificateGenerator.getSerialNumber("webapps/DBSConnector/SECURITY/PKCS12/"+CA+"/USERS/"+User+"/PKS/"+CU, FurPARAM.getDBSConnectorParam("CU_PASSWORD").DATA, User+"_cu");
    VARIABLES vvv = new VARIABLES();
      VAR[] tabV = new VAR[2];
      VAR v = new VAR();v.setName("[CA]");v.setValue(bb.toString(16));tabV[0]=v;
      v = new VAR();v.setName("[CU]");v.setValue(bb2.toString(16));tabV[1]=v;
      vvv.setVar(tabV);
      VARIABLES[] vvv2 = new VARIABLES[1]; vvv2[0]=vvv;
      ACTIVITYO sqloB = FurPRGM_9.STARTACTIVITY("{DBSConnector}" , "Revoke", vvv2);
      if (sqloB.getNBERR()>0) {
        b = false;
      }
  }
  catch (Exception e) { b=false;Fur_File.Trace("ERROR: FurPRGM_11.Revoke: "+e.getMessage());};
  return b;
};
public static boolean ValidCA(String PaCA) {
  return (!PaCA.equals("") && Fur_String.isCharListStartWith(PaCA, "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz") 
  && Fur_String.isValidCharList(PaCA, "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789"));
}
public static boolean isRevoke(String CA, String User, String CU) {
  String stt = "";
try {
    BigInteger bb = X509CertificateGenerator.getSerialNumber("webapps/DBSConnector/SECURITY/PKCS12/"+CA+"/ca.p12", FurPARAM.getDBSConnectorParam("CA_PASSWORD").DATA, "dbsconnector_ca");
    BigInteger bb2 = X509CertificateGenerator.getSerialNumber("webapps/DBSConnector/SECURITY/PKCS12/"+CA+"/USERS/"+User+"/PKS/"+CU, FurPARAM.getDBSConnectorParam("CU_PASSWORD").DATA, User+"_cu");
    VARIABLES vvv = new VARIABLES();
      VAR[] tabV = new VAR[2];
      VAR v = new VAR();v.setName("[CA]");v.setValue(bb.toString(16));tabV[0]=v;
      v = new VAR();v.setName("[CU]");v.setValue(bb2.toString(16));tabV[1]=v;
      vvv.setVar(tabV);
      VARIABLES[] vvv2 = new VARIABLES[1]; vvv2[0]=vvv;
      ACTIVITYO sqloB = FurPRGM_9.STARTACTIVITY("{DBSConnector}" , "isRevoke", vvv2);
      if (sqloB.getNBERR()>0) {
        if (sqloB.getMsgs().getMsg()!=null) {
          for(int y=0;y<sqloB.getMsgs().getMsg().length;y++) {
            Fur_File.Trace(sqloB.getMsgs().getMsg()[y].getTXT());
          }
        }
      } else {
      for(int y=0;y<sqloB.getVariables().length;y++) {
          for(int x=0;x<sqloB.getVariables()[y].getVar().length;x++) {
            stt=sqloB.getVariables()[y].getVar()[x].getValue();
          }
        }
     }
  }
  catch (Exception e) { Fur_File.Trace("ERROR: FurPRGM_11.isRevoke: "+e.getMessage());};
  if (stt.equals("0")) return false;
  else return true;
};
public static boolean stopDBSConnector() {
  boolean b = true;
  if (FurPARAM.getDBSConnectorParam("LOOK_DML_REQUEST").DATA.equals("False")) {
  Image image=null;
  try {
   Fur_File.Trace2("FurPRGM_11.STOPDBSCONNECTOR ---> BEGIN");
   
   VARIABLES[] vvv2 = new VARIABLES[1]; vvv2[0]=null;
   
   
   //On lance la demande d'arret sur tous les noeuds du cluster
   
   //Arret du loadbalancer pour bloquer toutes les nouvelles connexions ...
   Fur_File.Trace2("1) Stop the loadbalancer to block all new connections.");
   ACTIVITYO sqloB = FurPRGM_9.STARTACTIVITY("{DBSConnector}" ,"StopLoadBalancer", vvv2); 
   if (sqloB.getNBERR()==0) {Fur_File.Trace2("1-a) Desactivate all cluster node ---> OK");}
   else {
     for(int y=0;y<sqloB.getMsgs().getMsg().length;y++) {
       Fur_File.Trace2("1-a) Desactivate all cluster node ---> "+sqloB.getMsgs().getMsg()[y].getTXT());
     }
   }
   
   try {image=Toolkit.getDefaultToolkit().getImage("imgs/Jimmitry4848-1.png");
   FurTRAY.DBSCtrayIcon.setImage(image);Thread.currentThread().sleep(1000);} catch (Exception u) {}
   
   sqloB = FurPRGM_9.STARTACTIVITY("{DBSConnector}" ,"Stop2", vvv2);
   Fur_File.Trace2("2) It waits until all agents have stopped to continue ...");
   
   //On attent que tous les agents se sont arrêter pour continuer (on laisse terminer les demandes en cours)
   Fur_File.Trace2("2-a) Agent HTTP: "+LoadBalancerA.NbSession+" _ Agent HTTPS: "+LoadBalancerS.NbSession+" _ Agent HTTPS_Auth: "+LoadBalancerSAuth.NbSession);
   while (LoadBalancerA.NbSession!=0 && LoadBalancerS.NbSession!=0 && LoadBalancerSAuth.NbSession!=0) {
     Thread.currentThread().sleep(500);
   }
   
   try {image=Toolkit.getDefaultToolkit().getImage("imgs/Jimmitry4848-2.png");
   FurTRAY.DBSCtrayIcon.setImage(image);Thread.currentThread().sleep(1000);} catch (Exception u) {}
   
   Fur_File.Trace2("3) The wait staff is finished.");
   //L'attente des agents est terminé
   FurPRGM_5.Validate(Fur_File.getINIinfos("PARAM.INI", "CLUSTER_APP", "NODE_ID"), "1");
   
   try {image=Toolkit.getDefaultToolkit().getImage("imgs/Jimmitry4848-3.png");
   FurTRAY.DBSCtrayIcon.setImage(image);Thread.currentThread().sleep(1000);} catch (Exception u) {}
   
   sqloB = FurPRGM_9.STARTACTIVITY("{DBSConnector}" ,"Stop3", vvv2);
   Fur_File.Trace2("4) It waits the other nodes ...");
   //On attent les autres noeuds
   FurPRGM_5.Wait("1");
   
   try {image=Toolkit.getDefaultToolkit().getImage("imgs/Jimmitry4848-4.png");
   FurTRAY.DBSCtrayIcon.setImage(image);Thread.currentThread().sleep(1000);} catch (Exception u) {}
   
   sqloB = FurPRGM_9.STARTACTIVITY("{DBSConnector}" ,"Stop4", vvv2);
   Fur_File.Trace2("5) We stop all cron Activities ...");
   //On arreter tous les crons activities (avec un temps d'attente en chaque arret de cron, si trop long on passe au suivant, vérifier s'il y a toujours des soucis pour arreter un crontab proprement ?)
   FurSYS_SchedulerPOOLSql.stopALL();
   
   try {image=Toolkit.getDefaultToolkit().getImage("imgs/Jimmitry4848-5.png");
   FurTRAY.DBSCtrayIcon.setImage(image);Thread.currentThread().sleep(1000);} catch (Exception u) {}
   
   Fur_File.Trace2("6) All activities are crons ARRESTED.");
   //L'attente du scheduler est terminé
   FurPRGM_5.Validate(Fur_File.getINIinfos("PARAM.INI", "CLUSTER_APP", "NODE_ID"), "2");
   
   try {image=Toolkit.getDefaultToolkit().getImage("imgs/Jimmitry4848-6.png");
   FurTRAY.DBSCtrayIcon.setImage(image);Thread.currentThread().sleep(1000);} catch (Exception u) {}
   
   sqloB = FurPRGM_9.STARTACTIVITY("{DBSConnector}" ,"Stop5", vvv2);
   Fur_File.Trace2("7) It waits the other nodes ...");
   //On attent les autres noeuds
   FurPRGM_5.Wait("2");
   
   try {image=Toolkit.getDefaultToolkit().getImage("imgs/Jimmitry4848-7.png");
   FurTRAY.DBSCtrayIcon.setImage(image);Thread.currentThread().sleep(1000);} catch (Exception u) {}
   
   sqloB = FurPRGM_9.STARTACTIVITY("{DBSConnector}" ,"Stop6", vvv2);
   Fur_File.Trace2("8) It waits until all the activities during treatment ends ...");
   //On attent que toutes les activités en cours de traitement se termine
   long nbCurrent = 0;
   {
     Set cles = SQLPOOL.PoolSQL.keySet();
     Iterator it = cles.iterator();
     nbCurrent = 0;
     while (it.hasNext()){
       String cle = (String) it.next();
       nbCurrent+=SQLPOOL.RecupSQL(cle).NbCurrent;
     }
     Fur_File.Trace2("8-a) Current activities: "+nbCurrent);
     Thread.currentThread().sleep(500);
   } while (nbCurrent!=1);
   
   try {image=Toolkit.getDefaultToolkit().getImage("imgs/Jimmitry4848-8.png");
   FurTRAY.DBSCtrayIcon.setImage(image);Thread.currentThread().sleep(1000);} catch (Exception u) {}
   
   
   Fur_File.Trace2("9) The wait ends of the activities is.");
   //L'attente des activités est terminé
   FurPRGM_5.Validate(Fur_File.getINIinfos("PARAM.INI", "CLUSTER_APP", "NODE_ID"), "3");
   
   try {image=Toolkit.getDefaultToolkit().getImage("imgs/Jimmitry4848-9.png");
   FurTRAY.DBSCtrayIcon.setImage(image);Thread.currentThread().sleep(1000);} catch (Exception u) {}
   
   sqloB = FurPRGM_9.STARTACTIVITY("{DBSConnector}" ,"Stop7", vvv2);
   Fur_File.Trace2("10) It waits the other nodes ...");
   //On attent les autres noeuds
   FurPRGM_5.Wait("3");
   
   try {image=Toolkit.getDefaultToolkit().getImage("imgs/Jimmitry4848-10.png");
   FurTRAY.DBSCtrayIcon.setImage(image);} catch (Exception u) {}
   
   if (FurPARAM.getDBSConnectorParam("MODE_DEVEL").DATA.equals("True")) {
     Fur_File.deleteFileFolder("webapps/PORTAL/WEB-INF/web.xml");
     Fur_File.copyFile("webapps/PORTAL/WEB-INF-HTTP/web.xml", "webapps/PORTAL/WEB-INF/web.xml");
     Fur_File.copyFile("webapps/DBSConnector/WEB-INF/web-HTTP.xml", "webapps/DBSConnector/WEB-INF/web.xml");
   } else {
     Fur_File.deleteFileFolder("webapps/PORTAL/WEB-INF/web.xml");
     Fur_File.copyFile("webapps/PORTAL/WEB-INF-HTTPS/web.xml", "webapps/PORTAL/WEB-INF/web.xml");
     Fur_File.copyFile("webapps/DBSConnector/WEB-INF/web-HTTPS.xml", "webapps/DBSConnector/WEB-INF/web.xml");
   }
    //Fur_File.deleteFileFolder("work/Catalina");
    
   
    
   sqloB = FurPRGM_9.STARTACTIVITY("{DBSConnector}" ,"Stop8", vvv2);
   
   Fur_File.Trace2("FurPRGM_11.STOPDBSCONNECTOR ---> END");
   System.exit(0);
  }
  catch (Exception e) { b=false;Fur_File.Trace2("ERROR: FurPRGM_11.stopDBSConnector: "+e.getMessage());};
  }
  return b;
};
public static boolean stopDBSConnectorCluster() {
  boolean b = true;
  if (FurPARAM.getDBSConnectorParam("LOOK_DML_REQUEST").DATA.equals("False")) {
  try {
   VARIABLES[] vvv2 = new VARIABLES[1]; vvv2[0]=null;
   ACTIVITYO sqloB = FurPRGM_9.STARTACTIVITY("__CLUSTER" ,"STOPCLUSTER", vvv2); 
  }
  catch (Exception e) { b=false;Fur_File.Trace2("ERROR: FurPRGM_11.stopDBSConnectorCluster: "+e.getMessage());};
  }
  return b;
};
public static boolean stopDBSConnectorNoWait() {
  boolean b = true;
  if (FurPARAM.getDBSConnectorParam("LOOK_DML_REQUEST").DATA.equals("False")) {
  try {
   Fur_File.Trace2("FurPRGM_11.STOPDBSCONNECTORNOWAIT ---> BEGIN");
    
   if (FurPARAM.getDBSConnectorParam("MODE_DEVEL").DATA.equals("True")) {
     Fur_File.deleteFileFolder("webapps/PORTAL/WEB-INF/web.xml");
     Fur_File.copyFile("webapps/PORTAL/WEB-INF-HTTP/web.xml", "webapps/PORTAL/WEB-INF/web.xml");
     Fur_File.copyFile("webapps/DBSConnector/WEB-INF/web-HTTP.xml", "webapps/DBSConnector/WEB-INF/web.xml");
   } else {
     Fur_File.deleteFileFolder("webapps/PORTAL/WEB-INF/web.xml");
     Fur_File.copyFile("webapps/PORTAL/WEB-INF-HTTPS/web.xml", "webapps/PORTAL/WEB-INF/web.xml");
     Fur_File.copyFile("webapps/DBSConnector/WEB-INF/web-HTTPS.xml", "webapps/DBSConnector/WEB-INF/web.xml");
   }
    //Fur_File.deleteFileFolder("work/Catalina");
   
   Fur_File.Trace2("FurPRGM_11.STOPDBSCONNECTORNOWAIT ---> END");
   System.exit(0);
  }
  catch (Exception e) { b=false;Fur_File.Trace2("ERROR: FurPRGM_11.stopDBSConnectorNoWait: "+e.getMessage());};
  }
  return b;
};
}
